#![no_std]
#![no_main]
extern crate core;

use core::{
    arch::asm,
    ffi::c_void,
    mem,
    ptr
};
use shellcode_util::{get_module_handle_from_peb, get_procedure_from_edt};
use utf16_lit::utf16;
use windows_sys::{
    core::PCSTR,
    Win32::Foundation::{BOOL, HANDLE, HMODULE, HWND},
};

#[panic_handler]
pub fn panic(_panic: &core::panic::PanicInfo) -> ! {
    loop {}
}

// Always ensure _start() is at beginning of .text, despite what the linker thinks it should do.
// Placed at top of .text section in shellcode.ld, may not be needed since wildcard matches alphabetically
#[no_mangle]
#[link_section = ".text._start"]
unsafe extern "C" fn _start() {
    let kernel32 = get_module_handle_from_peb(&utf16!("KERNEL32.DLL")).unwrap();
    let LoadLibraryA: extern "system" fn(PCSTR) -> HMODULE =
        get_procedure_from_edt(kernel32, "LoadLibraryA\0").unwrap();
    let GetProcAddress: extern "system" fn(HMODULE, PCSTR) -> *const () =
        get_procedure_from_edt(kernel32, "GetProcAddress\0").unwrap();

    let user32 = LoadLibraryA("user32.dll\0".as_ptr());
    let MessageBoxA: extern "system" fn(HWND, PCSTR, PCSTR, u32) -> i32 =
        mem::transmute(GetProcAddress(user32, "MessageBoxA\0".as_ptr()));

    let GetStdHandle: extern "system" fn(u32) -> HANDLE =
        mem::transmute(GetProcAddress(kernel32, "GetStdHandle\0".as_ptr()));
    let output_handle = GetStdHandle(u32::MAX - 11);
    let WriteConsoleA: extern "system" fn(HANDLE, PCSTR, u32, *mut u32, *mut c_void) -> BOOL =
        mem::transmute(GetProcAddress(kernel32, "WriteConsoleA\0".as_ptr()));

    let text = "Hello from Console!\n\0";
    WriteConsoleA(
        output_handle,
        text.as_ptr(),
        text.len() as u32,
        ptr::null_mut(),
        ptr::null_mut(),
    );

    let text1 = "Hello World!\0";
    MessageBoxA(ptr::null_mut(), text1.as_ptr(), text1.as_ptr(), 0);

    let text2 = "Bye World\0";
    MessageBoxA(ptr::null_mut(), text2.as_ptr(), text2.as_ptr(), 0);

    let ExitProcess: extern "system" fn(u32) =
        mem::transmute(GetProcAddress(kernel32, "ExitProcess\0".as_ptr()));
    ExitProcess(4);
}